.386
.model flat,stdcall

include \masm32\include\kernel32.inc
include \masm32\include\setupapi.inc
include \masm32\include\rpcrt4.inc
include \masm32\include\user32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\setupapi.lib
includelib \masm32\lib\rpcrt4.lib
includelib \masm32\lib\user32.lib

.data?
hHeap DWORD ?
hMemDevInfoData DWORD ?
hMemDevIntData DWORD ?
usbGUID BYTE 16 DUP (?)
devGUID BYTE 16 DUP (?)
hDevInfo DWORD ?

.code
usb2GUID db "36fc9e60-c465-11cf-8056-444553540000",0 ;USB GUID
dev2GUID db "4d36e978-e325-11ce-bfc1-08002be10318",0
enum db "USB",0

start:
; Allocate memory

	;Create new private heap in process memory
	push 0h ;heap can grow
	push 0h ;allocates 1 page
	push 0h
	call HeapCreate ;use HeapDestroy to reverse
	mov hHeap,eax

	;hMemDevInfoData DWORD ?
	push 400h ;allocate 1024 bytes
	push 8h ;zero memory
	push hHeap
	call HeapAlloc ;use HeapFree to reverse
	mov hMemDevInfoData,eax
	
	;hMemDevIntData DWORD ?
	push 400h ;allocate 1024 bytes
	push 8h ;zero memory
	push hHeap
	call HeapAlloc ;use HeapFree to reverse
	mov hMemDevIntData,eax
	
	push offset usbGUID
	push offset usb2GUID
	call UuidToString

	push offset devGUID
	push offset dev2GUID
	call UuidToString

	mov dword ptr [hMemDevIntData+4],offset usbGUID
	
	push 10h ;DIGCF_DEVICEINTERFACE
	push 0h
	push 0h ;offset enum
	push offset usbGUID
	call SetupDiGetClassDevs
	mov hDevInfo,eax
	
	; check to see if function failed
	
	mov dword ptr [hMemDevInfoData],400h ;cbSize - 1024 bytes
	mov ecx,16
	mov esi,dword ptr [usbGUID]
	mov edi,[hMemDevInfoData+4]
	cld
	rep movsb
	mov dword ptr [hMemDevInfoData+20],offset hDevInfo
	
	mov dword ptr [hMemDevIntData],400h ;cbSize - 1024 bytes

	push hMemDevIntData
	push 0h
	push offset usbGUID
	push hMemDevInfoData
	push hDevInfo
	call SetupDiEnumDeviceInterfaces
	
	push hDevInfo
	call SetupDiDestroyDeviceInfoList
	push hHeap
	call HeapDestroy

	ret
end start